#include <GUIConstantsEx.au3>
#include <Memory.au3>
#include <Bass.au3>
#include <BassConstants.au3>

Opt("GUIOnEventMode", 1)

Global $iIndex = -1
Global $aNoten = _CalcFreq()

Global $hGui = GUICreate("Synth", 410, 200)
GUISetBkColor(0x0066AA)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "_Start")
GUISetOnEvent($GUI_EVENT_PRIMARYUP, "_Stop")
Global $hDummy = GUICtrlCreateDummy()
For $i = 0 To 12
	Switch $i
		Case 0, 2, 4, 5, 7, 9, 11, 12
			GUICtrlCreateLabel($aNoten[$i][0], $i * 30 + 10, 10, 28, 180)
			GUICtrlSetBkColor(-1, 0xFFFFFF)
		Case Else
			GUICtrlCreateLabel($aNoten[$i][0], $i * 30 + 10, 10, 28, 180)
			GUICtrlSetBkColor(-1, 0x000000)
			GUICtrlSetColor(-1, 0xFFFFFF)
	EndSwitch
Next
GUISetState()

_BASS_STARTUP(@ScriptDir & '\BASS.dll')
_BASS_Init(0, -1, 44100, 0, '')
If @error Then
	MsgBox(0, 'Error', 'Sound konnte nicht Initialisiert werden!')
	Exit
EndIf

$hStream = _BASS_StreamCreate(44100, 1, 0, "_StreamProc", 0)

While 1
	Sleep(1000)
WEnd

Func _Start()
	Local $aInfo = GUIGetCursorInfo($hGui)
	$iIndex = $aInfo[4] - $hDummy - 1
	If $iIndex > 12 Then $iIndex = -1
	_BASS_ChannelPlay($hStream, True)
EndFunc   ;==>_Start

Func _Stop()
	_BASS_ChannelStop($hStream)
	$iIndex = -1
EndFunc   ;==>_Stop

Func _StreamProc($handle, $buffer, $length, $user)
	Local Static $iOff = 0
	If $iIndex < 0 Then
		$iOff = 0
		Return False;$length
	EndIf
	$length -= Mod($length, 2) ; weil ein short = 2 bytes sind
	_MemMoveMemory($aNoten[$iIndex][3] + $iOff, $buffer, $length)
	$iOff = Round(Mod($length + $iOff, (44100 / $aNoten[$iIndex][1]) * 2)) ; Offset zum nchsten Nulldurchgang berechnen
	$iOff += Mod($iOff, 2) ; weil ein short = 2 bytes sind
	Return $length
EndFunc   ;==>_StreamProc

Func _CalcSine($tStruct, $nFreq)
	Local Const $pi = ATan(1) * 4
	For $i = 1 To 44100
		DllStructSetData($tStruct, 1, 32767 * Sin($i * $pi * 2 / (44100 / $nFreq)), $i)
	Next
EndFunc   ;==>_CalcSine

Func _CalcFreq()
	Local $aReturn[13][4]
	Local $nFreq = 61.7354126570155 * 5
	Local $aNoten[13] = ["C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "H", "C"]
	Local $iCnt = 0
	For $j In $aNoten
		ToolTip("please wait..." & $iCnt & "/12")
		$nFreq = $nFreq * 2 ^ (1 / 12)
		$aReturn[$iCnt][0] = $j
		$aReturn[$iCnt][1] = Round($nFreq, 2)
		$aReturn[$iCnt][2] = DllStructCreate("short[44100]")
		$aReturn[$iCnt][3] = DllStructGetPtr($aReturn[$iCnt][2])
		_CalcSine($aReturn[$iCnt][2], $nFreq)
		$iCnt += 1
	Next
	ToolTip("")
	Return $aReturn
EndFunc   ;==>_CalcFreq

Func _Exit()
	_BASS_ChannelStop($hStream)
	_BASS_Stop()
	_BASS_Free()
	Exit
EndFunc   ;==>_Exit